import papi.atk, atexit

# A simple AtkValueIface implementation.
class SimpleValue (papi.atk.AtkObject):
    def __init__ (self):

        # Create out AtkObject, but also let it implement the AtkValue
        # interface.
        papi.atk.AtkObject.__init__ (self, papi.atk.ATK_IFACE_VALUE)

        self._value = 0

        # Override the necessary interfaces of the AtkValue.
        self.value_get_current_value = self._get_current_value
        self.value_get_maximum_value = self._get_max_value
        self.value_get_minimum_value = self._get_min_value
        self.value_set_current_value = self._set_current_value
        self.value_get_minimum_increment = self._get_min_increment

    def _get_current_value (self):
        return self._value
    
    def _get_max_value (self):
        return 0xFFFF
    
    def _get_min_value (self):
        return 0
    
    def _set_current_value (self, val):
        self._value = int (val)
        
    def _get_min_increment (self):
        return 1
    
# Create the main application
application = papi.atk.AtkObject ()
application.name = "AtkValue Application"
application.description = "An AtkValue demonstration example."
application.role = papi.atk.ATK_ROLE_APPLICATION

# Set the applicaiton object as root, register the shutdown method, so
# all gets cleaned up nicely and start the ATK system.
papi.atk.set_root (application)
atexit.register (papi.atk.shutdown)
papi.atk.init ()

# Create a value object and denote it as a spin button in the object
# hierarchy.
action = SimpleValue ()
action.name = "Simple AtkValue"
action.description = "A simple AtkValue."
action.role = papi.atk.ATK_ROLE_SPIN_BUTTON

# Set the parent of the value, so that it can be placed correctly
# within the object hierarchy.
action.parent = application

print "Press CTRL-C to exit the application."
while True:
    # Deal with the events by letting the ATK-System process them.
    papi.atk.iterate ()
